#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include "winsock.h"

#define WSVERS	MAKEWORD(2, 0)

void errexit(const char *format, ...)
{
	va_list args;
	
	va_start(args, format);
	vfprintf(stderr, format, args);
	va_end(args);
	
	printf("\n");
	
	WSACleanup();
	
	exit(1);
}

int main(int argc, char * argv[])
{
	/* connection setting */
	char *host = "localhost";
	char *port = "9999";
	
	/* socket data*/
	WSADATA wsadata;
	struct sockaddr_in sin;		/* an Internet endpoint address */
	struct hostent * hptr;
	struct protoent *ppe;
	int type;
	SOCKET s;
	
	/* Other Declare */
	char buf[1024];
	int cc;

	/* start WinSock*/
	if(WSAStartup(WSVERS, &wsadata) != 0)
		errexit("WSAStartup faild");

	memset(&sin, 0, sizeof(sin));
	sin.sin_family = PF_INET;
	sin.sin_port = htons( (u_short) atoi(port) ) ;
		
	/* ]w IP */
	if(hptr = gethostbyname(host))
		memcpy(&sin.sin_addr, hptr->h_addr, hptr->h_length);
	else if( (sin.sin_addr.s_addr = inet_addr(host)) == INADDR_NONE)
		errexit("can't get \"%s\" host entry", host);

	/* ]w TCP/UDP */
	if((ppe = getprotobyname("tcp")) == 0)
		errexit("can't get \"%s\" prototype entry", "tcp");
	type = SOCK_STREAM;	/* tcp */
	
	/* Allocate a socket */ 
	s = socket(PF_INET, type, ppe->p_proto); 
	if (s == INVALID_SOCKET) 
		errexit("can't create socket: %d\n", GetLastError());
	else
		puts("Created socked.");
		
	/* Connect the socket */ 
 	if (connect(s, (struct sockaddr *)&sin, sizeof(sin)) == SOCKET_ERROR) 
		errexit("can't connect to %s.%s: %d\n", host, port, GetLastError());
	else
		puts("connected to Server.");
	
	puts("Receive msg from server:");  
	
	/* }lŪ */
	cc = recv(s, buf, sizeof(buf)-1, 0);
	while(cc != SOCKET_ERROR && cc>0)
	{
		buf[cc] = '\0';
		puts(buf);
		
		cc = recv(s, buf, sizeof(buf)-1, 0);
	}
	
	/* close a socket*/
	closesocket(s);
	
	/* End WinSock*/
	WSACleanup();
	
	return 0;
}
