#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include "winsock.h"

#define WSVERS	MAKEWORD(2, 0)

void errexit(const char *format, ...)
{
	va_list args;
	
	va_start(args, format);
	vfprintf(stderr, format, args);
	va_end(args);
	
	printf("\n");
	
	WSACleanup();
	
	exit(1);
}

int main(int argc, char * argv[])
{
	/* connection setting */
	char *host = "localhost";
	char *port = "9999";
	
	/* socket data*/
	WSADATA wsadata;
	struct sockaddr_in sin;		/* an Internet endpoint address */
	struct sockaddr_in fsin;	/* the address of a client */ 
	struct protoent *ppe;
	int type;
	SOCKET s, ssock;
	int qlen = 5;				/* maximum connection queue length */
	int alen;					/* length of client's address */
	
	/* Other Declare */
	char buf[1024];
	int cc;

	/* start WinSock*/
	if(WSAStartup(WSVERS, &wsadata) != 0)
		errexit("WSAStartup faild");

	memset(&sin, 0, sizeof(sin));
	sin.sin_family = PF_INET;
	sin.sin_addr.s_addr = INADDR_ANY;
	sin.sin_port = htons( (u_short) atoi(port) ) ;

	/* ]w TCP/UDP */
	if((ppe = getprotobyname("tcp")) == 0)
		errexit("can't get \"%s\" prototype entry", "tcp");
	type = SOCK_STREAM;	/* tcp */
	
	/* Allocate a socket */ 
	s = socket(PF_INET, type, ppe->p_proto); 
	if (s == INVALID_SOCKET) 
		errexit("can't create socket: %d\n", GetLastError());
	else
		puts("Created Server socket.");
		
	/* Bind the socket */ 
 	if (bind(s, (struct sockaddr *)&sin, sizeof(sin)) == SOCKET_ERROR) 
		errexit("can't bind to %s %d\n", port, GetLastError());  
	else
		puts("bind.");
	
	/* listen */
	if( type == SOCK_STREAM && listen(s, qlen) == SOCKET_ERROR)
		errexit("can't listen on %s port: %d\n", port, GetLastError());
	else
		puts("listen.");
		
	while(1)
	{
		alen = sizeof(fsin);
		ssock = accept(s, (struct sockaddr *) &fsin, &alen);
		
		if(ssock == INVALID_SOCKET)
			errexit("accept: err number %d", GetLastError());
			
		puts("client connected.");
		puts("Please send msg, 'q' leave:");
			
		do
		{
			gets(buf);
			if(send(ssock, buf, strlen(buf), 0) == SOCKET_ERROR)
			{
				fprintf(stderr, "send err:%d", GetLastError());
				break;
			}
		}while(buf[0] != 'q');
		
		closesocket(ssock);
		
		break;
	}
	
	/* close a scoet*/
	closesocket(s);
	
	/* End WinSock*/
	WSACleanup();
	
	return 0;
}
